#include <Cg/cg.h>
#include <Cg/cgGL.h>
#include "shared/RenderTexture.h"
#include "glh/glh_linear.h"
#include "NVIFilter.h"

using namespace glh;
typedef vec<2, int> vec2i;
typedef glh::array2<float> Image2D;

void init_convolve(bool use_half, int components, bool use_tex2D, bool use_looping);
void destroy_convolve();

float *evaluateFilter1D(NVIFilter2D &filter, int radius, int &nsamples, bool normalize);
Image2D *evaluateFilter2D(NVIFilter2D &filter, int radius_x, int radius_y, bool normalize);
Image2D *evaluateFilterAtlas2D(NVIFilter2D &filter, int nkernels, int max_radius, float min_r, float max_r);

GLuint createTextureFromImage2D(Image2D &img, GLenum target, GLenum internalFormat);
GLuint createTextureFromImage1D(float *data, int width, GLenum target, GLenum internalFormat);

CGprogram createConvolveProgram(int nsamples, float *weights, vec2f *offsets, bool use_tex2D);

CGprogram createConvolutionProgramSeparable(NVIFilter2D &filter, int radius, bool use_filtering, bool vertical, bool use_tex2D, int image_w, int image_h);
CGprogram createConvolutionProgram2D(NVIFilter2D &filter, int radius_x, int radius_y, bool use_tex2D, int image_w, int image_h);

CGprogram createConvolveProgramTex(int kernel_width, int kernel_height, int xoffset, int yoffset, bool use_tex2D, int img_width, int img_height);
CGprogram createConvolveProgramTexSeparable(int kernel_width, int offset, bool use_tex2D, bool vertical, int img_width, int img_height);

void setDepthScaleBias(float scale, float bias);
CGprogram createConvolveProgramTexSteerable(int kernel_width, int kernel_height, int xoffset, int yoffset, int nkernels, bool use_tex2D, int img_width, int img_height);
